#include <GUIListView.au3>
#include <ComboConstants.au3>
#include <Array.au3>

#include "Include\GUIs.au3"
#include "Include\Utilities.au3"

If ProcessList("extensa.exe")[0][0] > 1 Then
	MsgBox(48, "Multiple Instances", "Oops!" & @CRLF & _
									 "Looks like you've started Extensa although it was already running!" & @CRLF & _
									 "Extensa only allows once instance of the program to be running.")
	Exit
EndIf

If ProcessList("extensaw.exe")[0][0] Then
	;Worker beenden
	_KillWorker()
EndIf

Global $iDevice = Number(IniRead("settings.ini", "Settings", "Device", "")), $iCurrentProfile

If IniRead("settings.ini", "Settings", "FirstStart", "1") = "1" Then
	MsgBox(48, "Important Message", "Please read the manual in order to get Extensa to work." & @CRLF & _
									"You must install interception for this.")

	IniWrite("settings.ini", "Settings", "FirstStart", "0")
EndIf

If $iDevice = 0 Then
	ShellExecute("Device Identifier.exe")
	Exit
EndIf

Local $aDeviceKeyList[0]
$hExtensaGUI = GUICreate("Extensa - Device: " & $iDevice, 474, 353)
$hDeviceLV = GUICtrlCreateListView("Command|Key|ScanCode|Tap Style", 8, 8, 458, 278)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 0, 130)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 1, 95)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 2, 95)
GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 3, 117)
$hAddKey = GUICtrlCreateButton("Add Key", 7, 290, 75, 25)
$hEditKey = GUICtrlCreateButton("Edit Key", 87, 290, 75, 25)
$hRemoveKey = GUICtrlCreateButton("Remove Key", 167, 290, 75, 25)
$hAddToAutoStart = GUICtrlCreateCheckbox("Add to Autostart", 368, 294, 97, 17)
GUICtrlSetState(-1, FileExists(@StartupDir & "\extensaw.lnk"))
$hStartWorker = GUICtrlCreateButton("Start Worker", 255, 290, 107, 25)
$hAddProfile = GUICtrlCreateButton("Add Profile", 8, 320, 73, 25)
$hProfileList = GUICtrlCreateCombo("", 256, 322, 209, 25, $CBS_DROPDOWNLIST)
;~ GUICtrlCreateLabel("Current Profile:", 170, 326, 73, 17)
$hDeleteProfile  = GUICtrlCreateButton("Delete Profile", 88, 320, 73, 25)
$hAbout = GUICtrlCreateButton("About Extensa", 168, 320, 73, 25)

;Vorhandene Profile auslesen
$aProfiles = IniReadSectionNames("settings.ini")
_ArrayDelete($aProfiles, 0)

For $i = 0 To UBound($aProfiles) - 1
	If $aProfiles[$i] = "Settings" Then
		_ArrayDelete($aProfiles, $i)
		ExitLoop
	EndIf
Next

;Wenn kein Profil vorhanden, dann erstelle ein Standardprofil namens "Commands"
If Not UBound($aProfiles) Then
	ReDim $aProfiles[1]
	$aProfiles[0] = "Commands"
	IniWrite("settings.ini", "Settings", "CurrentProfile", "0")
	IniWriteSection("settings.ini", "Commands", "")
EndIf

;Ausgewähltes Profil lesen
$iCurrentProfile = IniRead("settings.ini", "Settings", "CurrentProfile", "0")

;Falls jemand in der settings.ini rumpfuscht und die Integrität verletzt
If $iCurrentProfile + 1 > UBound($aProfiles) Then
	IniWrite("settings.ini", "Settings", "CurrentProfile", "0")
	$iCurrentProfile = 0
EndIf

;Wenn nur ein Profil verfügbar ist, dann darf man es nicht löschen können
If UBound($aProfiles) = 1 Then GUICtrlSetState($hDeleteProfile, 128)

_LoadProfile($iCurrentProfile, $aProfiles, $hProfileList)
_LoadKeys($iCurrentProfile, $hDeviceLV, $aDeviceKeyList)

GUISetState(@SW_SHOW, $hExtensaGUI)

While Sleep(10)
	Switch GUIGetMsg()
		Case -3
			Switch MsgBox(32 + 3, "Exiting Extensa", "Do you want to start the worker?")
				Case 6
					_KillWorker()
					ShellExecute("extensaw.exe", "Start") ;Falls der Windows-Scheduler die If-Abfrage des Workers vorher abarbeitet wird der Worker beendet,
														  ;weil er denkt das Main-Programm liefe noch obwohl es jeden Augenblick beendet wird.
					Exit

				Case 7
					Exit

			EndSwitch

		Case $hAbout
			MsgBox(32, "About Extensa " & FileGetVersion(@ScriptFullPath, "FileVersion"), _
					   "Extensa " & FileGetVersion(@ScriptFullPath, "FileVersion") & " (" & FileGetVersion(@ScriptFullPath, "Comments") & ") by alpines ~ autoit.de" & @CRLF & _
						@CRLF & _
						"Check the thread for updates:" & @CRLF & _
						"https://autoit.de/index.php/Thread/84272" & @CRLF & _
						@CRLF & _
						"With Extensa you can assign hotkeys to specific keyboards without affecting other keyboards." & @CRLF & _
						@CRLF & _
						"Do you have suggestions, feedback or want to get something about this program off your chest? Tell me about it!" & @CRLF & _
						@CRLF & _
						"You can either leave a few words in the thread or write me a personal message on the autoit.de forum.", 0, $hExtensaGUI)

		Case $hStartWorker
			_KillWorker()
			ShellExecute("extensaw.exe", "Start") ;Siehe Kommentar zum vorherigen ShellExecute (GUI Switch Case -3)
			Exit

		Case $hProfileList
			Local $sSelectedProfile = GUICtrlRead($hProfileList)

			If $sSelectedProfile <> $aProfiles[$iCurrentProfile] Then
				$iCurrentProfile = _ArraySearch($aProfiles, $sSelectedProfile)
				_LoadKeys($iCurrentProfile, $hDeviceLV, $aDeviceKeyList)
				IniWrite("settings.ini", "Settings", "CurrentProfile", $iCurrentProfile)
			EndIf

		Case $hAddProfile
			Local $sResult = _AddProfileGUI($aProfiles, $hExtensaGUI)

			GUICtrlSetData($hProfileList, "")
			GUICtrlSetData($hProfileList, _ArrayToString($aProfiles))
			ControlCommand($hExtensaGUI, "", $hProfileList, "SelectString", $aProfiles[$iCurrentProfile])

			_LoadKeys($iCurrentProfile, $hDeviceLV, $aDeviceKeyList)

			;Wenn ein Profil hinzugefügt wurde
			If StringLen($sResult) Then
				ReDim $aProfiles[UBound($aProfiles) + 1]
				$aProfiles[UBound($aProfiles) - 1] = $sResult
				$iCurrentProfile = UBound($aProfiles) - 1

				IniWrite("settings.ini", "Settings", "CurrentProfile", $iCurrentProfile)
				IniWriteSection("settings.ini", $sResult, "")

				_LoadProfile($iCurrentProfile, $aProfiles, $hProfileList)

				;Löscht alte Einträge und lädt keine Keys
				_LoadKeys($iCurrentProfile, $hDeviceLV, $aDeviceKeyList)

				GUICtrlSetState($hDeleteProfile, 64)

				ReDim $aDeviceKeyList[0]
			EndIf


		Case $hDeleteProfile
			If MsgBox(48 + 4, "Deleting Profile", "Are you sure you want to delete the profile " & $aProfiles[$iCurrentProfile] & "?" & @CRLF & _
												  "You will lose " & UBound($aDeviceKeyList) & " of the assigned key bindings.") = 6 Then

				IniDelete("settings.ini", $aProfiles[$iCurrentProfile])
				_ArrayDelete($aProfiles, $iCurrentProfile)

				$iCurrentProfile = 0
				_LoadProfile($iCurrentProfile, $aProfiles, $hProfileList)
				_LoadKeys($iCurrentProfile, $hDeviceLV, $aDeviceKeyList)

				;Wenn nur ein Profil verfügbar ist soll man es nicht löschen können
				If UBound($aProfiles) = 1 Then GUICtrlSetState($hDeleteProfile, 128)
			EndIf

		Case $hAddToAutoStart
			Switch BitAND(GUICtrlRead($hAddToAutoStart), 1)
				Case 1
					FileCreateShortcut(@ScriptDir & "\extensaw.exe", @StartupDir & "\extensaw.lnk", @ScriptDir)
				Case 0
					FileDelete(@StartupDir & "\extensaw.lnk")
			EndSwitch

		Case $hAddKey
			GUICtrlSetState($hAddKey, 128)
			$hDLL = DllOpen("InterceptionHelper.dll")

			Do
				ToolTip("Waiting for key press!")
				$aGetKey = _GetKey($hDLL)
			Until $aGetKey[0] = $iDevice

			DllClose($hDLL)

			ToolTip("")
			GUICtrlSetState($hAddKey, 64)

			If $aGetKey[0] <> $iDevice Then
				MsgBox(48, "Wrong Device", "You used the wrong device.")
			Else
				Local $aResult = _AddKeyGUI($aGetKey[1], $hExtensaGUI)

				If UBound($aResult) Then
					$bWrite = True
					If IniRead("settings.ini", $aProfiles[$iCurrentProfile], $aResult[2], "") <> "" Then
						$aSavedCommand = StringSplit(IniRead("settings.ini", $aProfiles[$iCurrentProfile], $aResult[2], ""), "|", 3)

						If MsgBox(52, "Multiple Commands", "There is already a command assigned to the scancode." & @CRLF & _
															@CRLF & _
															"Command: " & @TAB & $aSavedCommand[0] & @CRLF & _
															"Command Input: " & @TAB & $aSavedCommand[1] & @CRLF & _
															"Scan Code: " & @TAB & $aSavedCommand[2] & @CRLF & _
															"Key:" & @TAB & @TAB & $aScanCodes[$aSavedCommand[2]] & @CRLF & _
															"Tap Style:" & @TAB & @TAB & ($aSavedCommand[3] = 1 ? "OnPress" : $aSavedCommand[3] = 0 ? "OnRelease" : "OnToggle") & @CRLF & _
															@CRLF & _
															"Do you want to overwrite it with this command?" & @CRLF & _
															@CRLF & _
															"Command: " & @TAB & $aResult[0] & @CRLF & _
															"Command Input: " & @TAB & $aResult[1] & @CRLF & _
															"Scan Code: " & @TAB & $aResult[2] & @CRLF & _
															"Key:" & @TAB & @TAB & $aScanCodes[$aResult[2]] & @CRLF & _
															"Tap Style:" & @TAB & @TAB & ($aResult[3] = 1 ? "OnPress" : $aResult[3] = 0 ? "OnRelease" : "OnToggle") & @CRLF & _
															@CRLF) = 7 Then $bWrite = False
					EndIf

					If $bWrite Then
						ReDim $aDeviceKeyList[UBound($aDeviceKeyList) + 1]
						$aDeviceKeyList[UBound($aDeviceKeyList) - 1] = GUICtrlCreateListViewItem(_AbbreviateCommand($aResult[0]) & "|" & $aScanCodes[$aResult[2]] & "|" & $aResult[2] & "|" & ($aResult[3] = 1 ? "OnPress" : $aResult[3] = 0 ? "OnRelease" : "OnToggle"), $hDeviceLV)
						IniWrite("settings.ini", $aProfiles[$iCurrentProfile], $aResult[2], $aResult[0] & "|" & $aResult[1] & "|" & $aResult[2] & "|" & $aResult[3])
					EndIf
				EndIf
			EndIf

		Case $hEditKey
			$iIndex = Number(_GUICtrlListView_GetSelectedIndices($hDeviceLV))

			If StringLen(_GUICtrlListView_GetSelectedIndices($hDeviceLV)) Then
				$aKey = StringSplit(IniRead("settings.ini", $aProfiles[$iCurrentProfile], _GUICtrlListView_GetItemText($hDeviceLV, $iIndex, 2), ""), "|", 3)

				$aResult = _AddKeyGUI($aKey, $hExtensaGUI)
				If UBound($aResult) Then
					GUICtrlSetData($aDeviceKeyList[$iIndex], _AbbreviateCommand($aResult[0]) & "|" & $aScanCodes[$aResult[2]] & "|" & $aResult[2] & "|" & ($aResult[3] = 1 ? "OnPress" : $aResult[3] = 0 ? "OnRelease" : "OnToggle"))
					IniWrite("settings.ini", $aProfiles[$iCurrentProfile], $aResult[2], $aResult[0] & "|" & $aResult[1] & "|" & $aResult[2] & "|" & $aResult[3])
				EndIf
			EndIf

		Case $hRemoveKey
			If StringLen(_GUICtrlListView_GetSelectedIndices($hDeviceLV)) Then
				For $i = 0 To UBound($aDeviceKeyList) - 1
					If Number(_GUICtrlListView_GetSelectedIndices($hDeviceLV)) = $i Then
						$aSavedCommand = StringSplit(IniRead("settings.ini", $aProfiles[$iCurrentProfile], _GUICtrlListView_GetItemText($hDeviceLV, $i, 2), ""), "|", 3)

						If MsgBox(52, "Removing Command", "Are you sure you want to delete this assigned command?" & @CRLF & _
														  @CRLF & _
														  "Command: " & @TAB & $aSavedCommand[0] & @CRLF & _
														  "Command Input: " & @TAB & $aSavedCommand[1] & @CRLF & _
														  "Scan Code: " & @TAB & $aSavedCommand[2] & @CRLF & _
														  "Key:" & @TAB & @TAB & $aScanCodes[$aSavedCommand[2]] & @CRLF & _
														  "Tap Style:" & @TAB & @TAB & ($aSavedCommand[3] = 1 ? "OnPress" : $aSavedCommand[3] = 0 ? "OnRelease" : "OnToggle")) = 6 Then

							IniDelete("settings.ini", $aProfiles[$iCurrentProfile], $aSavedCommand[2])
							_GUICtrlListView_DeleteItem($hDeviceLV, $i)
							_ArrayDelete($aDeviceKeyList, $i)
							ExitLoop
						Else
							ExitLoop
						EndIf
					EndIf
				Next
			EndIf
	EndSwitch
WEnd

Func _LoadProfile($iProfile, $aProfiles, $hProfileList)
	GUICtrlSetData($hProfileList, "")
	GUICtrlSetData($hProfileList, _ArrayToString($aProfiles))
	ControlCommand($hExtensaGUI, "", $hProfileList, "SelectString", $aProfiles[$iProfile])
EndFunc

Func _LoadKeys($iProfile, $hDeviceLV, ByRef $aDeviceKeyList)
	For $i = 0 To UBound($aDeviceKeyList) - 1
		GUICtrlDelete($aDeviceKeyList[$i])
	Next

	_GUICtrlListView_DeleteAllItems($hDeviceLV)

	$aSection = IniReadSection("settings.ini", $aProfiles[$iCurrentProfile])

	If UBound($aSection) Then
		ReDim $aDeviceKeyList[$aSection[0][0]]

		For $i = 1 To $aSection[0][0]
			$aTmp = StringSplit($aSection[$i][1], "|", 3)
			$aDeviceKeyList[UBound($aDeviceKeyList) - 1] = GUICtrlCreateListViewItem(_AbbreviateCommand($aTmp[0]) & "|" & $aScanCodes[$aTmp[2]] & "|" & $aTmp[2] & "|" & ($aTmp[3] = 1 ? "OnPress" : $aTmp[3] = 0 ? "OnRelease" : "OnToggle"), $hDeviceLV)
		Next
	EndIf
EndFunc