#include "Include\_AudioEndpointVolume.au3"
#include "Include\Utilities.au3"

;Siehe für Erklärung Extensa.au3
If ProcessList("extensa.exe")[0][0] and Not $CMDLine[0] Then
	MsgBox(48, "Main Program running", "Oops!" & @CRLF & _
									   "Looks like you've started the worker although the main program was alredy running." & @CRLF & _
									   "The worker can only be started if the main program is not running or" & @CRLF & _
									   "if you started the worker from the main program.")
	Exit
EndIf

If ProcessList("extensaw.exe")[0][0] > 1 Then
	MsgBox(48, "Multiple Instances", "Oops!" & @CRLF & _
									 "Looks like you've started the worker although one was already running!" & @CRLF & _
									 "Extensa only allows once instance of the worker to be running.")
	Exit
EndIf

Global $hDLL = DllOpen("InterceptionHelper.dll")

Global $iDevice = IniRead("settings.ini", "Settings", "Device", "")
Global $iCurrentProfile = IniRead("settings.ini", "Settings", "CurrentProfile", "0")
Global $aProfiles = IniReadSectionNames("settings.ini")

Global $oWMP = 0
GLobal $bHold = False

Global $aCommands[0][0][0]

;0 Index löschen, Settings Index löschen
For $i = 2 To UBound($aProfiles) - 1
	$aProfiles[$i - 2] = $aProfiles[$i]
Next

ReDim $aProfiles[UBound($aProfiles) - 2]

If $iDevice = "" Then
	MsgBox(48, "No Device", "The worker can not run if you didn't specify a device.")
	Exit
EndIf

ReDim $aCommands[UBound($aProfiles)][0][5]

For $i = 0 To UBound($aCommands) - 1
	Local $aSection = IniReadSection("settings.ini", $aProfiles[$i])

	If UBound($aSection) Then
		If UBound($aCommands, 2) < $aSection[0][0] Then ReDim $aCommands[UBound($aProfiles)][$aSection[0][0]][5]

		For $j = 1 To $aSection[0][0]
			$aTmp = StringSplit($aSection[$j][1], "|", 3)

			$aCommands[$i][$j - 1][0] = $aSection[$j][0] ;ScanCode
			$aCommands[$i][$j - 1][1] = $aTmp[0]		 ;Command
			$aCommands[$i][$j - 1][2] = $aTmp[1]		 ;Command Input
			$aCommands[$i][$j - 1][3] = Number($aTmp[3]) ;Tap Style (0 OnRelease, 1 OnPress, 2 OnToggle)
			$aCommands[$i][$j - 1][4] = 0				 ;Toggle State
		Next
	EndIf
Next

While 1
	$aKey = _GetKey($hDLL, $iDevice)

	If $aKey[0] = $iDevice Then
		For $i = 0 To UBound($aCommands, 2) - 1
			If $aCommands[$iCurrentProfile][$i][0] = "" Then ExitLoop

			If $aKey[1] = $aCommands[$iCurrentProfile][$i][0] Then
				Switch $aCommands[$iCurrentProfile][$i][1]
					Case "Execute File"
						If $aCommands[$iCurrentProfile][$i][3] = $aKey[2] Then ShellExecute($aCommands[$iCurrentProfile][$i][2])

					Case "Keystrokes - Send strokes"
						If $aCommands[$iCurrentProfile][$i][3] = $aKey[2] Then Send($aCommands[$iCurrentProfile][$i][2])

					Case "Radio - Turn On/Off"
						If Not $bHold and $aKey[2] Then
							$bHold = True

							If Not $aCommands[$iCurrentProfile][$i][4] Then
								$oWMP = ObjCreate("WMPlayer.ocx")
								_StreamRadio($oWMP, $aCommands[$iCurrentProfile][$i][2], True)
								$aCommands[$iCurrentProfile][$i][4] = 1
							Else
								_StreamRadio($oWMP, "", False)
								$aCommands[$iCurrentProfile][$i][4] = 0
							EndIf
						ElseIf Not $aKey[2] and $bHold Then
							$bHold = False
						EndIf

					Case "Radio - Mute/Unmute"
						If Not $bHold and $aKey[2] Then
							$bHold = True

							If $oWMP <> 0 Then $oWMP.settings.mute = Not $oWMP.settings.mute
						ElseIf $bHold and Not $aKey[2] Then
							$bHold = False
						EndIf

					Case "Radio - Increase Volume (+2)"
						If $aCommands[$iCurrentProfile][$i][3] = $aKey[2] Then
							If $oWMP <> 0 Then $oWMP.settings.Volume = $oWMP.settings.Volume + 2
						EndIf

					Case "Radio - Decrease Volume (-2)"
						If $aCommands[$iCurrentProfile][$i][3] = $aKey[2] Then
							If $oWMP <> 0 Then $oWMP.settings.Volume = $oWMP.settings.Volume - 2
						EndIf

					Case "Extensa - Switch to previous profile"
						If $aCommands[$iCurrentProfile][$i][3] = $aKey[2] Then
							$iCurrentProfile -= 1
							If $iCurrentProfile = -1 Then $iCurrentProfile = UBound($aProfiles) - 1
						EndIf

					Case "Extensa - Switch to next profile"
						If $aCommands[$iCurrentProfile][$i][3] = $aKey[2] Then
							$iCurrentProfile += 1
							If $iCurrentProfile = UBound($aProfiles) Then $iCurrentProfile = 0
						EndIf

					Case "Volume - Increase (+2)"
						If $aCommands[$iCurrentProfile][$i][3] = $aKey[2] Then _SetMasterVolumeLevelScalar(_GetMasterVolumeLevelScalar() + 2)

					Case "Volume - Decrease (-2)"
						If $aCommands[$iCurrentProfile][$i][3] = $aKey[2] Then  _SetMasterVolumeLevelScalar(_GetMasterVolumeLevelScalar() - 2)

					Case "Volume - Mute/Unmute"
						If Not $bHold and $aKey[2] Then
							$bHold = True

							_SetMute(_GetMute() ? 0 : 1)
						ElseIf $bHold and Not $aKey[2] Then
							$bHold = False
						EndIf
				EndSwitch
			EndIf
		Next
	EndIf
WEnd